summaryrefslogtreecommitdiffstats
path: root/patches/source/openjpeg/openjpeg.SlackBuild
diff options
context:
space:
mode:
Diffstat (limited to 'patches/source/openjpeg/openjpeg.SlackBuild')
-rwxr-xr-xpatches/source/openjpeg/openjpeg.SlackBuild121
1 files changed, 121 insertions, 0 deletions
diff --git a/patches/source/openjpeg/openjpeg.SlackBuild b/patches/source/openjpeg/openjpeg.SlackBuild
new file mode 100755
index 00000000..7be4e4f1
--- /dev/null
+++ b/patches/source/openjpeg/openjpeg.SlackBuild
@@ -0,0 +1,121 @@
+#!/bin/sh
+
+# Slackware build script for openjpeg
+
+# Copyright 2008-2014 Heinz Wiesinger, Amsterdam, The Netherlands
+# Copyright 2014, 2017 Patrick J. Volkerding, Sebeka, MN, USA
+# All rights reserved.
+#
+# Redistribution and use of this script, with or without modification, is
+# permitted provided that the following conditions are met:
+#
+# 1. Redistributions of this script must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ''AS IS'' AND ANY EXPRESS OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
+# EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
+# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
+# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
+# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
+# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+PKGNAM=openjpeg
+VERSION=${VERSION:-$(echo $PKGNAM-*.tar.?z* | rev | cut -f 3- -d . | cut -f 1 -d - | rev)}
+BUILD=${BUILD:-1_slack14.2}
+
+NUMJOBS=${NUMJOBS:--j7}
+
+# Automatically determine the architecture we're building on:
+MARCH=$( uname -m )
+if [ -z "$ARCH" ]; then
+ case "$MARCH" in
+ i?86) export ARCH=i586 ;;
+ armv7hl) export ARCH=$MARCH ;;
+ arm*) export ARCH=arm ;;
+ # Unless $ARCH is already set, use uname -m for all other archs:
+ *) export ARCH=$MARCH ;;
+ esac
+fi
+
+if [ "$ARCH" = "i586" ]; then
+ SLKCFLAGS="-O2 -march=i586 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "s390" ]; then
+ SLKCFLAGS="-O2"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "x86_64" ]; then
+ SLKCFLAGS="-O2 -fPIC"
+ LIBDIRSUFFIX="64"
+elif [ "$ARCH" = "armv7hl" ]; then
+ SLKCFLAGS="-O2 -march=armv7-a -mfpu=vfpv3-d16"
+ LIBDIRSUFFIX=""
+else
+ SLKCFLAGS="-O2"
+ LIBDIRSUFFIX=""
+fi
+
+CWD=$(pwd)
+TMP=${TMP:-/tmp}
+PKG=$TMP/package-openjpeg
+
+rm -rf $PKG
+mkdir -p $TMP $PKG
+cd $TMP
+rm -rf openjpeg-$VERSION
+tar xvf $CWD/openjpeg-$VERSION.tar.?z* || exit 1
+cd openjpeg-$VERSION || exit 1
+chown -R root:root .
+find . \
+ \( -perm 777 -o -perm 775 -o -perm 711 -o -perm 555 -o -perm 511 \) \
+ -exec chmod 755 {} \; -o \
+ \( -perm 666 -o -perm 664 -o -perm 600 -o -perm 444 -o -perm 440 -o -perm 400 \) \
+ -exec chmod 644 {} \;
+
+zcat $CWD/openjpeg2_remove-thirdparty.patch.gz | patch -p1 --verbose || exit 1
+
+mkdir -p build
+cd build
+ cmake \
+ -DCMAKE_C_FLAGS="$SLKCFLAGS" \
+ -DCMAKE_CXX_FLAGS="$SLKCFLAGS" \
+ -DCMAKE_INSTALL_PREFIX=/usr \
+ -DOPENJPEG_INSTALL_LIB_DIR="lib$LIBDIRSUFFIX" \
+ -DOPENJPEG_INSTALL_MAN_DIR="man/" \
+ -DOPENJPEG_INSTALL_DOC_DIR="doc/openjpeg-$VERSION/" \
+ -DOPENJPEG_INSTALL_SHARE_DIR="share/openjpeg" \
+ -DBUILD_JPWL:BOOL=ON \
+ -DBUILD_MJ2:BOOL=ON \
+ -DBUILD_JPIP:BOOL=ON \
+ -DBUILD_JP3D:BOOL=ON \
+ .. || exit 1
+
+ make $NUMJOBS || make || exit 1
+ make install DESTDIR=$PKG || exit 1
+cd -
+
+# Some libs require the openjpeg.h used for openmj2.
+# This version is pretty much the old version from openjpeg 1.5
+mkdir -p $PKG/usr/include/openmj2-2.1
+install -m 644 src/lib/openmj2/openjpeg.h $PKG/usr/include/openmj2-2.1/
+
+mkdir -p $PKG/usr/man
+cp -r doc/man/* $PKG/usr/man/
+
+find $PKG | xargs file | grep -e "executable" -e "shared object" | grep ELF \
+ | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null || true
+
+find $PKG/usr/man -type f -exec gzip -9 {} \;
+
+mkdir -p $PKG/usr/doc/openjpeg-$VERSION
+cp -a AUTHORS* CHANGES* INSTALL* LICENSE* NEWS* README* THANKS* \
+ $PKG/usr/doc/openjpeg-$VERSION
+
+mkdir -p $PKG/install
+cat $CWD/slack-desc > $PKG/install/slack-desc
+
+cd $PKG
+/sbin/makepkg -l y -c n $TMP/openjpeg-$VERSION-$ARCH-$BUILD.txz